Attribute VB_Name = "deplacements"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

' Cherche les pos2 d'un pion en pos1
Public Function coups(ByVal pos1 As Integer) As Integer()

Dim IntTampon As Integer ' Pour tester les coups du roi si chec
Dim i As Integer, j As Integer
Dim sortir As Boolean ' Pour quitter la boucle (ex: tour)
Dim coups_tmp() As Integer
    
    Select Case Abs(position.pions(pos1))
    
        '------------------------------------------------------------------------
        '   CHEVAUX
        '------------------------------------------------------------------------
        
        Case 4

            If tab120(tab64(pos1) - 21) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 17) <= 0 Then Call array_push(coups_tmp, pos1 - 17) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) + 21) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 17) <= 0 Then Call array_push(coups_tmp, pos1 + 17) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) - 8) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 6) <= 0 Then Call array_push(coups_tmp, pos1 - 6) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) + 8) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 6) <= 0 Then Call array_push(coups_tmp, pos1 + 6) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) - 12) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 10) <= 0 Then Call array_push(coups_tmp, pos1 - 10) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) + 12) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 10) <= 0 Then Call array_push(coups_tmp, pos1 + 10) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) - 19) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 15) <= 0 Then Call array_push(coups_tmp, pos1 - 15) ' cf. les indices de tab64
            End If
            If tab120(tab64(pos1) + 19) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 15) <= 0 Then Call array_push(coups_tmp, pos1 + 15) ' cf. les indices de tab64
            End If
            
    
        '------------------------------------------------------------------------
        '   PIONS
        '------------------------------------------------------------------------
        
        Case 6
            ' Pions blancs qui montent
            If position.pions(pos1) > 0 Then
                ' Case suprieure
                If tab120(tab64(pos1) - 10) > -1 Then
                    If position.pions(pos1 - 8) = 0 Then Call array_push(coups_tmp, pos1 - 8)
                End If
                ' 2me case si le pion est sur la ligne de dpart
                If pos1 > 47 And pos1 < 56 Then
                    If position.pions(pos1 - 16) = 0 And position.pions(pos1 - 8) = 0 Then Call array_push(coups_tmp, pos1 - 16)
                End If
                ' Prise en haut  gauche
                If tab120(tab64(pos1) - 11) > -1 Then
                    If position.pions(pos1) * position.pions(pos1 - 9) < 0 Then Call array_push(coups_tmp, pos1 - 9)
                End If
                ' Prise en haut  droite
                If tab120(tab64(pos1) - 9) > -1 Then
                    If position.pions(pos1) * position.pions(pos1 - 7) < 0 Then Call array_push(coups_tmp, pos1 - 7)
                End If
                ' Prise en passant
                ' Si un pion noir vient d'avancer de 2 cases
                ' best_pos1 peut fonctionner quand l'ia cherche les coups blancs ? non
                'If best_pos1 >= 8 And best_pos1 <= 15 And best_pos2 >= 24 And best_pos2 <= 31 And position.pions(pos2) = -6 Then
                'End If
        
            ' Pions noirs qui descendent
            Else
                ' Case suprieure
                If tab120(tab64(pos1) + 10) > -1 Then
                    If position.pions(pos1 + 8) = 0 Then Call array_push(coups_tmp, pos1 + 8)
                End If
                ' 2me case si le pion est sur la ligne de dpart
                If pos1 > 7 And pos1 < 16 Then
                    If position.pions(pos1 + 16) = 0 And position.pions(pos1 + 8) = 0 Then Call array_push(coups_tmp, pos1 + 16)
                End If
                ' Prise en bas  gauche
                If tab120(tab64(pos1) + 9) > -1 Then
                    If position.pions(pos1) * position.pions(pos1 + 7) < 0 Then Call array_push(coups_tmp, pos1 + 7)
                End If
                ' Prise en bas  droite
                If tab120(tab64(pos1) + 11) > -1 Then
                    If position.pions(pos1) * position.pions(pos1 + 9) < 0 Then Call array_push(coups_tmp, pos1 + 9)
                End If
                ' Prise en passant
            End If
        
        '------------------------------------------------------------------------
        '   TOURS
        '------------------------------------------------------------------------
        
        Case 5

            ' Axe Horizontal HAUT
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (10 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (8 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (8 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (8 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Axe Vertical BAS
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (10 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (8 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (8 * j)) ' cf. les indices de tab64
                    i = i + 1
                    If position.pions(pos1) * position.pions(pos1 + (8 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Axe Horizontal GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (1 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (1 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (1 * j)) ' cf. les indices de tab64
                    i = i + 1
                    If position.pions(pos1) * position.pions(pos1 - (1 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Axe Horizontal DROIT
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (1 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (1 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (1 * j)) ' cf. les indices de tab64
                    i = i + 1
                    If position.pions(pos1) * position.pions(pos1 + (1 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
        
        '------------------------------------------------------------------------
        '   FOUS
        '------------------------------------------------------------------------
        
        Case 3

            ' Diagonale HAUT-DROITE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (9 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (7 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (7 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (7 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Diagonale BAS-DROITE
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (11 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (9 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (9 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (9 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
        
            ' Diagonale BAS-GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (9 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (7 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (7 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (7 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
            ' Diagonale HAUT-GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (11 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (9 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (9 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (9 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
        '------------------------------------------------------------------------
        '   ROI
        '------------------------------------------------------------------------
        
        Case 1
            ' GAUCHE
            If tab120(tab64(pos1) - 1) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 1) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 - 1)
                    position.pions(pos1 - 1) = position.pions(pos1)
                    position.pions(pos1) = 0
                    ' S'il n'est pas en chec, ok pour le coup
                    If is_attacked(pos1 - 1) = -1 Then
                        Call array_push(coups_tmp, pos1 - 1) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 - 1)
                    position.pions(pos1 - 1) = IntTampon
                End If
            End If
            
            ' DROITE
            If tab120(tab64(pos1) + 1) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 1) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 + 1)
                    position.pions(pos1 + 1) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 + 1) = -1 Then
                        Call array_push(coups_tmp, pos1 + 1) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 + 1)
                    position.pions(pos1 + 1) = IntTampon
                End If
            End If
            
            ' HAUT
            If tab120(tab64(pos1) - 10) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 8) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 - 8)
                    position.pions(pos1 - 8) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 - 8) = -1 Then
                        Call array_push(coups_tmp, pos1 - 8) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 - 8)
                    position.pions(pos1 - 8) = IntTampon
                End If
            End If
            
            ' BAS
            If tab120(tab64(pos1) + 10) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 8) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 + 8)
                    position.pions(pos1 + 8) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 + 8) = -1 Then
                        Call array_push(coups_tmp, pos1 + 8) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 + 8)
                    position.pions(pos1 + 8) = IntTampon
                End If
            End If
            
            ' HAUT-GAUCHE
            If tab120(tab64(pos1) - 11) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 9) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 - 9)
                    position.pions(pos1 - 9) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 - 9) = -1 Then
                        Call array_push(coups_tmp, pos1 - 9) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 - 9)
                    position.pions(pos1 - 9) = IntTampon
                End If
            End If
            
            ' HAUT-DROITE
            If tab120(tab64(pos1) - 9) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 - 7) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 - 7)
                    position.pions(pos1 - 7) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 - 7) = -1 Then
                        Call array_push(coups_tmp, pos1 - 7) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 - 7)
                    position.pions(pos1 - 7) = IntTampon
                End If
            End If
            
            ' BAS-GAUCHE
            If tab120(tab64(pos1) + 9) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 7) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 + 7)
                    position.pions(pos1 + 7) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 + 7) = -1 Then
                        Call array_push(coups_tmp, pos1 + 7) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 + 7)
                    position.pions(pos1 + 7) = IntTampon
                End If
            End If
            
            ' BAS-DROITE
            If tab120(tab64(pos1) + 11) > -1 Then ' cf. les valeurs de tab64
                If position.pions(pos1) * position.pions(pos1 + 9) <= 0 Then
                    ' On bouge le roi
                    IntTampon = position.pions(pos1 + 9)
                    position.pions(pos1 + 9) = position.pions(pos1)
                    position.pions(pos1) = 0
                    If is_attacked(pos1 + 9) = -1 Then
                        Call array_push(coups_tmp, pos1 + 9) ' cf. les indices de tab64
                    End If
                    ' On remet le pion
                    position.pions(pos1) = position.pions(pos1 + 9)
                    position.pions(pos1 + 9) = IntTampon
                End If
            End If
            
            ' ROQUE (IF imbriqus=plus performants !)
            If position.pions(pos1) < 0 Then
                ' Pour le roi noir
                If position.noir_peut_petit_roque = True Then
                    If position.pions(7) = -5 Then ' Corrige le bug du roque sans tour
                        If position.pions(5) = 0 Then
                            If position.pions(6) = 0 Then
                                If is_attacked(5) = -1 Then
                                    If is_attacked(6) = -1 Then
                                        If is_attacked(pos1) = -1 Then
                                            Call array_push(coups_tmp, 6)
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
                
                If position.noir_peut_grand_roque = True Then
                    If position.pions(0) = -5 Then ' Corrige le bug du roque sans tour
                        If position.pions(1) = 0 Then
                            If position.pions(2) = 0 Then
                                If position.pions(3) = 0 Then
                                    If is_attacked(1) = -1 Then
                                        If is_attacked(2) = -1 Then
                                            If is_attacked(3) = -1 Then
                                                If is_attacked(pos1) = -1 Then
                                                    Call array_push(coups_tmp, 2)
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            
            Else
                ' Pour le roi blanc
                If position.blanc_peut_petit_roque = True Then
                    If position.pions(63) = 5 Then ' Corrige le bug du roque sans tour
                        If position.pions(61) = 0 Then
                            If position.pions(62) = 0 Then
                                If is_attacked(61) = -1 Then
                                    If is_attacked(62) = -1 Then
                                        If is_attacked(pos1) = -1 Then
                                            Call array_push(coups_tmp, 62)
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
                
                If position.blanc_peut_grand_roque = True Then
                    If position.pions(56) = 5 Then ' Corrige le bug du roque sans tour
                        If position.pions(57) = 0 Then
                            If position.pions(58) = 0 Then
                                If position.pions(59) = 0 Then
                                    If is_attacked(57) = -1 Then
                                        If is_attacked(58) = -1 Then
                                            If is_attacked(59) = -1 Then
                                                If is_attacked(pos1) = -1 Then
                                                    Call array_push(coups_tmp, 58)
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
            
        '------------------------------------------------------------------------
        '   DAME
        '------------------------------------------------------------------------
        
        Case 2

            ' Axe Vertical HAUT
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (10 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (8 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (8 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (8 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Axe Vertical BAS
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (10 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (8 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (8 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (8 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
            ' Axe Horizontal GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (1 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (1 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (1 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (1 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
            ' Axe Horizontal DROIT
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (1 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (1 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (1 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (1 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Diagonale HAUT-DROITE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (9 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (7 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (7 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (7 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend

            ' Diagonale BAS-DROITE
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (11 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (9 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (9 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (9 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
        
            ' Diagonale BAS-GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) + (9 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 + (7 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 + (7 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 + (7 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
            ' Diagonale HAUT-GAUCHE
            sortir = False
            j = 1
            While tab120(tab64(pos1) - (11 * j)) > -1 And sortir = False
                If position.pions(pos1) * position.pions(pos1 - (9 * j)) <= 0 Then ' cf. les valeurs de tab64
                    Call array_push(coups_tmp, pos1 - (9 * j)) ' cf. les indices de tab64
                    If position.pions(pos1) * position.pions(pos1 - (9 * j)) < 0 Then sortir = True
                Else
                    sortir = True
                End If
                j = j + 1
            Wend
            
    End Select

coups = coups_tmp

End Function

' Dplace un pion
Sub domove(ByVal pos1 As Integer, ByVal pos2 As Integer)
    
    Dim i As Integer ' Pour les prises de pions
    Dim init_id_pion_pos1 As Integer
    
    init_id_pion_pos1 = position.pions(pos1)
        
    ' On bouge les pions dans la position
    ' On bouge le pions pos1->pos2
    position.pions(pos2) = position.pions(pos1)
    position.pions(pos1) = 0
    
    ' Si on a bouge une tour de sa case initiale on dsactive le roque
    If position.pions(pos2) = -5 Then
        If pos1 = 0 Then
            position.noir_peut_grand_roque = False
        ElseIf pos1 = 7 Then
            position.noir_peut_petit_roque = False
        End If
    ElseIf position.pions(pos2) = 5 Then
        If pos1 = 56 Then
            position.blanc_peut_grand_roque = False
        ElseIf pos1 = 63 Then
            position.blanc_peut_petit_roque = False
        End If
    ' Si on a bouge un roi de sa case initiale
    ElseIf position.pions(pos2) = -1 Then
        If pos1 = 4 Then
            ' On dsactive le roque
            position.noir_peut_grand_roque = False
            position.noir_peut_petit_roque = False
            ' Si on roque, on bouge la tour
            If pos2 = 2 Then
                position.pions(0) = 0
                position.pions(3) = -5
            ElseIf pos2 = 6 Then
                position.pions(7) = 0
                position.pions(5) = -5
            End If
        End If
    ElseIf position.pions(pos2) = 1 Then
        If pos1 = 60 Then
            ' On dsactive le roque
            position.blanc_peut_grand_roque = False
            position.blanc_peut_petit_roque = False
            ' Si on roque, on bouge la tour
            If pos2 = 58 Then
                position.pions(56) = 0
                position.pions(59) = 5
            ElseIf pos2 = 62 Then
                position.pions(63) = 0
                position.pions(61) = 5
            End If
        End If
    End If
    
    ' Si on a une promotion, le pion devient dame
    If Abs(position.pions(pos2)) = 6 And ((pos2 >= 0 And pos2 <= 7) Or (pos2 >= 56 And pos2 <= 63)) Then
        If position.pions(pos2) > 0 Then
            position.pions(pos2) = 2
        Else
            position.pions(pos2) = -2
        End If
    End If
    
    ' Si on a un pion noir en promotion, il devient dame
    If init_id_pion_pos1 = -6 And pos2 >= 56 And pos2 <= 63 Then
        position.pions(pos2) = -2
    End If

    ' La partie a commence
    partie_commencee = True

End Sub

Public Function generer_liste_coup(ByVal color As Boolean) As LstCoup

    Dim i As Integer, j As Integer, k As Integer, IntStep As Integer
    Dim tmpcoups() As Integer
    Dim element
    Dim couleur_pion_player As Integer
    Dim TmpListe As LstCoup

    If color = True Then
        couleur_pion_player = -1
        j = 63: k = 0: IntStep = -1
    Else
        couleur_pion_player = 1
        j = 0: k = 63: IntStep = 1
    End If

    ' On rempli le tableau de tous les coups jouables par "color"
    For i = j To k Step IntStep
        ' Si le pion est de la "color" recherche
        If position.pions(i) * couleur_pion_player > 0 Then
            tmpcoups = coups(i)
            If array_is_empty(tmpcoups) = False Then
                For Each element In tmpcoups
                    array_push TmpListe.pos1, i
                    array_push TmpListe.pos2, element
                Next element
            End If
        End If
    Next i

    generer_liste_coup = TmpListe

End Function

