Attribute VB_Name = "IA_search"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

Public Sub Search(profondeur As Integer, alpha As Integer, beta As Integer, color As Boolean)

    Dim eval As Integer, IntBest As Integer
    Dim liste_coup As LstCoup
    Dim pos1 As Integer, pos2 As Integer
    Dim i As Integer
    Dim tmppos As echiquier
    
    IntBest = -INFINITY
    
    ' On gnre la liste des coups de l'chiquier
    liste_coup = generer_liste_coup(color)
    
    ' S'il n'y a pas de coups noirs : PAT
    If array_is_empty(liste_coup.pos1) = True Then
        bloquer_ordi = True ' Ceci empche l'ordi de jouer le coup trouv
        bloquer_joueur = True ' Ceci empche les blancs de jouer
        MsgBox "Pat !" & vbNewLine & "Partie nulle."
        Exit Sub
    End If

    For i = 0 To UBound(liste_coup.pos1)
        
        pos1 = liste_coup.pos1(i)
        pos2 = liste_coup.pos2(i)
         
        ' On joue le coups
        tmppos = position
        domove pos1, pos2

        eval = -AlphaBeta(profondeur - 1, -beta, -alpha, Not color)
'        Dim k As Byte
'        For k = 1 To profondeur: Print #1, "          ";: Next k
'        Print #1, "p" & profondeur & ":" & pos1 & "-" & pos2 & ":eval=" & eval
        
        ' On dfait le coups (prcdent chiquier)
        position = tmppos
        
        If eval > IntBest Then IntBest = eval
        If IntBest >= beta Then Exit For
        If IntBest > alpha Then
            alpha = IntBest
            best_pos1 = pos1
            best_pos2 = pos2
            frm_board.lbl_bestcoup = notation_historique(pos1, pos2)
        End If
        
    Next i
    
End Sub
