Attribute VB_Name = "var_globales"
'----------------------------------------------------------------------------------------------
'WJChess 0.61 par Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Programme d 'checs pour Win32.
'Ecrit en Visual Basic 6.0
'
'LICENSE
'Ce code source peut tre copi et distribu librement, sans tre modifi.
'Il est fourni sans aucune garanti et support technique.
'Vous pouvez le modifier pour votre usage personnel.
'Vous ne pouvez pas modifier le code source et le distribuer, sous forme compile
'ou non, sans l'accord de l'auteur : Jean-Franois GAZET (jeffgazet@free.fr).
'
'----------------------------------------------------------------------------------------------
'WJChess 0.61 by Jean-Franois GAZET (jeffgazet@free.fr)
'http://wjchess.jeffprod.com
'----------------------------------------------------------------------------------------------
'
'Chess program for Windows 32 bits.
'Written in Visual Basic 6.0
'
'LICENSE
'This source code can be copied and distributed freely, without any modification.
'It comes without any garanty and technical support.
'You can modify it for your own use.
'You can 't modify the source code and distribute it, compiled or not, without the
'author agreement : Jean-Franois GAZET (jeffgazet@free.fr).
'----------------------------------------------------------------------------------------------

Option Explicit

'--------------------------------------------------------------------
' Dclaration des variables globales pour tout le programme
'--------------------------------------------------------------------

' PIONS
' Blancs : 1=roi, 2=reine, 3=fou, 4=cavalier, 5=tour, 6=pion
' Noirs : idem blancs en ngatif (-1,-2,-3, etc...)
Public Type echiquier ' Structure d'un chiquier
    pions(0 To 63) As Integer
    blanc_peut_petit_roque As Boolean
    blanc_peut_grand_roque As Boolean
    noir_peut_petit_roque As Boolean
    noir_peut_grand_roque As Boolean
End Type
Public position As echiquier ' Echiquier en cours et modifi par la recherche
Public valeurs_pions(1 To 6) As Integer ' Valeurs des pions

' ECHIQUIER
Public couleur_case(0 To 63) As String ' Couleur des cases vides pour les images (n ou b)
Public tab64(0 To 63) As Integer ' Pour la mthode "mail box" de Bob Hyatt
Public tab120(0 To 119) As Integer ' Pour la mthode "mail box" de Bob Hyatt
Public partie_commencee As Boolean ' Pour savoir si une partie a commenc afin de ne pas demander confirmation "arrter?" si clic sur "nouvelle partie"

' DEPLACEMENTS
Public Type LstCoup ' Pour la gnrer la liste des coups
    pos1() As Integer
    pos2() As Integer
End Type
Public best_pos1 As Integer, best_pos2 As Integer ' Meilleur coup trouv  la fin de la recherche

' IA
Public Const INFINITY = 32000
Public init_prof As Integer ' Rglage de la profondeur en option
Public bonus_cases(0 To 63) As Integer

' ENVIRONNEMENT
Public bloquer_joueur As Boolean ' Pour empcher le joueur de jouer
Public bloquer_ordi As Boolean ' Pour empcher l'ordi de jouer
Public temps_ordi As Integer, temps_player As Integer ' Horloges des joueurs
Public cpt_historique As Integer
Public coordonnee_case(0 To 63) As String ' Coordonnes des cases pour l'historique (a1, c6, etc...)
